#include "buffer.h"
#include "exit.h"
#include "logmsg.h"
#include "ip.h"
#include "dns.h"

#define WHO "dnsname"

static char seed[128];

char ip6[16];
static stralloc out;

int main(int argc,char **argv)
{
  dns_random_init(seed);

  if (*argv) ++argv;

  while (*argv) {
    if (ip6_scan(*argv,ip6)) {
      if (dns_name(&out,ip6) == -1)
        logmsg(WHO,111,FATAL,B("unable to find host name for: ",*argv));
    }

    buffer_put(buffer_1,out.s,out.len);
    buffer_puts(buffer_1,"\n");

    ++argv;
  }

  buffer_flush(buffer_1);
  _exit(0);
}
